Index: branches/2011/dev_r2802_NOCL_Smagorinsky/NEMOGCM/CONFIG/GYRE/EXP00/namelist
===================================================================
--- branches/2011/dev_r2802_NOCL_Smagorinsky/NEMOGCM/CONFIG/GYRE/EXP00/namelist	(revision 2939)
+++ branches/2011/dev_r2802_NOCL_Smagorinsky/NEMOGCM/CONFIG/GYRE/EXP00/namelist	(revision 2940)
@@ -27,5 +27,5 @@
    cn_exp      =  "GYRE"   !  experience name 
    nn_it000    =       1   !  first time step
-   nn_itend    =    4320   !  last  time step
+   nn_itend    =    26600   !  last  time step
    nn_date0    =  010101   !  initial calendar date yymmdd (used if nn_rstctl=1)
    nn_leapy    =      30   !  Leap year calendar (1) or not (0)
@@ -84,5 +84,5 @@
    rn_e3zps_rat=    0.1    !  rn_e3zps_min and rn_e3zps_rat*e3t, with 0<rn_e3zps_rat<1
                            !
-   rn_rdt      = 7200.     !  time step for the dynamics (and tracer if nn_acc=0)
+   rn_rdt      =  1440.     !  time step for the dynamics (and tracer if nn_acc=0)
    nn_baro     =   60      !  number of barotropic time step            ("key_dynspg_ts")
    rn_atfp     =    0.1    !  asselin time filter parameter
@@ -478,7 +478,8 @@
    ln_traldf_gdia   =  .false.  !  griffies operator strfn diagnostics  (require "key_ldfslp")  ! UNDER TEST, DO NOT USE
    !                       !  Coefficient
-   rn_aht_0         =  1000.    !  horizontal eddy diffusivity for tracers [m2/s]
+   rn_aht_0         =     1.    !  horizontal eddy diffusivity for tracers [m2/s]
    rn_ahtb_0        =     0.    !  background eddy diffusivity for ldf_iso [m2/s]
    rn_aeiv_0        =     0.    !  eddy induced velocity coef. [m2/s]   (require "key_traldf_eiv")
+   rn_chsmag        =     1.    !  coefficient in Smagorinsky diffusivity
 /
 !-----------------------------------------------------------------------
@@ -554,7 +555,9 @@
    ln_dynldf_iso    =  .false.  !  iso-neutral                          (require "key_ldfslp")
    !                       !  Coefficient
-   rn_ahm_0_lap     = 100000.   !  horizontal laplacian eddy viscosity   [m2/s]
+   rn_ahm_0_lap     =    10.   !  horizontal laplacian eddy viscosity   [m2/s]
    rn_ahmb_0        =     0.    !  background eddy viscosity for ldf_iso [m2/s]
    rn_ahm_0_blp     =     0.    !  horizontal bilaplacian eddy viscosity [m4/s]
+   rn_cmsmag_1       =     3.    !  coefficient in Smagorinsky viscosity for laplacian case
+   rn_cmsmag_2       =     3.    !  coefficient in Smagorinsky viscosity for bilaplacian case 
 /
 
Index: branches/2011/dev_r2802_NOCL_Smagorinsky/NEMOGCM/CONFIG/GYRE/cpp_GYRE.fcm
===================================================================
--- branches/2011/dev_r2802_NOCL_Smagorinsky/NEMOGCM/CONFIG/GYRE/cpp_GYRE.fcm	(revision 2939)
+++ branches/2011/dev_r2802_NOCL_Smagorinsky/NEMOGCM/CONFIG/GYRE/cpp_GYRE.fcm	(revision 2940)
@@ -1,1 +1,1 @@
- bld::tool::fppkeys key_gyre key_dynspg_flt key_ldfslp key_zdftke key_vectopt_loop key_iomput
+ bld::tool::fppkeys key_gyre key_dynspg_flt key_ldfslp key_zdftke   key_mpp_mpi key_traldf_c3d key_traldf_smag key_dynldf_smag key_dynldf_c3d
Index: branches/2011/dev_r2802_NOCL_Smagorinsky/NEMOGCM/NEMO/OPA_SRC/par_GYRE.h90
===================================================================
--- branches/2011/dev_r2802_NOCL_Smagorinsky/NEMOGCM/NEMO/OPA_SRC/par_GYRE.h90	(revision 2939)
+++ branches/2011/dev_r2802_NOCL_Smagorinsky/NEMOGCM/NEMO/OPA_SRC/par_GYRE.h90	(revision 2940)
@@ -19,5 +19,5 @@
 #endif
       :: &
-      jp_cfg =  1   ,        &  !: 
+      jp_cfg =  5   ,        &  !: 
 
       ! data size              !!! * size of all the input files *
Index: branches/2011/dev_r2802_NOCL_Smagorinsky/NEMOGCM/TOOLS/COMPILE/cfg.txt
===================================================================
--- branches/2011/dev_r2802_NOCL_Smagorinsky/NEMOGCM/TOOLS/COMPILE/cfg.txt	(revision 2939)
+++ branches/2011/dev_r2802_NOCL_Smagorinsky/NEMOGCM/TOOLS/COMPILE/cfg.txt	(revision 2940)
@@ -1,3 +1,2 @@
-GYRE OPA_SRC
 ORCA2_LIM_PISCES OPA_SRC LIM_SRC_2 NST_SRC TOP_SRC
 GYRE_LOBSTER OPA_SRC TOP_SRC
@@ -6,2 +5,6 @@
 ORCA2_LIM3 OPA_SRC LIM_SRC_3
 ORCA2_LIM OPA_SRC LIM_SRC_2 NST_SRC
+GYRE_5
+GYRE_0 OPA_SRC
+GYRE_5 OPA_SRC
+GYRE OPA_SRC