Index: branches/2011/dev_LOCEAN_2011/NEMOGCM/CONFIG/GYRE_LOBSTER/EXP00/namelist_lobster
===================================================================
--- branches/2011/dev_LOCEAN_2011/NEMOGCM/CONFIG/GYRE_LOBSTER/EXP00/namelist_lobster	(revision 2976)
+++ branches/2011/dev_LOCEAN_2011/NEMOGCM/CONFIG/GYRE_LOBSTER/EXP00/namelist_lobster	(revision 2977)
@@ -98,8 +98,6 @@
 /
 !'''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
-&namlobdia     !   additional 2D/3D tracers diagnostics ("key_trc_diaadd")
+&namlobdia     !   additional 2D/3D tracers diagnostics
 !,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,
-   nn_writedia =  360  !  time step frequency for tracers diagnostics
-!
 !              !    name   ! title of   ! units !
 !              !           ! the field  !       !  
@@ -130,9 +128,5 @@
 &namlobdbi     !   biological diagnostics trends     
 !,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,
-!                !  3D bio diagnostics   units : mmole/m3/s   ("key_trc_diabio")
 !                !  2D bio diagnostics   units : mmole/m2/s   ("key_trdmld_trc")
-
-   nwritebio    =   4320    !  time step frequency for biological outputs
-!
 !                !  name    !       title of the field      !     units      !
    lobdiabio(1)  = 'NO3PHY' , 'Flux from NO3 to PHY          ',  'mmole/m3/s'
Index: branches/2011/dev_LOCEAN_2011/NEMOGCM/CONFIG/GYRE_LOBSTER/EXP00/namelist_top
===================================================================
--- branches/2011/dev_LOCEAN_2011/NEMOGCM/CONFIG/GYRE_LOBSTER/EXP00/namelist_top	(revision 2976)
+++ branches/2011/dev_LOCEAN_2011/NEMOGCM/CONFIG/GYRE_LOBSTER/EXP00/namelist_top	(revision 2977)
@@ -1,36 +1,50 @@
 !!>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
-!! NEMO/TOP1 :  1 - tracer definition                     (namtrc    )
-!! namelists    2 - dynamical tracer trends               (namtrc_trd)
-!!              3 - tracer advection                      (namtrc_adv)
-!!              4 - tracer lateral diffusion              (namtrc_ldf)
-!!              5 - tracer vertical physics               (namtrc_zdf)
-!!              6 - tracer newtonian damping              (namtrc_dmp)
+!! NEMO/TOP2 namelits :  1 - tracer definition                     (namtrc    )
+!!                       2 - tracer advection                      (namtrc_adv)
+!!                       3 - tracer lateral diffusion              (namtrc_ldf)
+!!                       4 - tracer vertical physics               (namtrc_zdf)
+!!                       5 - tracer newtonian damping              (namtrc_dmp)
+!!                       6 - dynamical tracer trends               (namtrc_trd)
+!!                       7 - tracer output                         (namtrc_wri)
 !>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
 !'''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
 &namtrc     !   tracers definition
 !,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,
+!
    nn_dttrc      =  1        !  time step frequency for passive sn_tracers
-   nn_writetrc   =  360      !  time step frequency for sn_tracer outputs
+   nn_writetrc   =  60      !  time step frequency for sn_tracer outputs
    ln_rsttr      = .false.   !  start from a restart file (T) or not (F)
-   nn_rsttr      =   0       !  restart control = 0 initial time step is not compared to the restart file value
+   nn_rsttr      =   1       !  restart control = 0 initial time step is not compared to the restart file value
                            !                  = 1 do not use the value in the restart file
                            !                  = 2 calendar parameters read in the restart file
-   cn_trcrst_in  = "restart_trc"   !  suffix of pass. sn_tracer restart name (input)
+   cn_trcrst_in  = "restart_trc.nc"   !  suffix of pass. sn_tracer restart name (input)
    cn_trcrst_out = "restart_trc"   !  suffix of pass. sn_tracer restart name (output)
+   ln_trcdta     =   .false.    !  Initialisation from data input file (T) or not (F)
 !
-!              ! name  !     title of the field       !   units       ! initial data ! save   !
-!              !       !                              !               ! from file    ! or not ! 
-!              !       !                              !               ! or not       !        !
-   sn_tracer(1)   = 'DET' , 'Detritus                   ',  'mmole-N/m3' ,  .false.     ,  .true.
-   sn_tracer(2)   = 'ZOO' , 'Zooplankton concentration  ',  'mmole-N/m3' ,  .false.     ,  .true.
-   sn_tracer(3)   = 'PHY' , 'Phytoplankton concentration',  'mmole-N/m3' ,  .false.     ,  .true.
-   sn_tracer(4)   = 'NO3' , 'Nitrate concentration      ',  'mmole-N/m3' ,  .false.     ,  .true.
-   sn_tracer(5)   = 'NH4' , 'Ammonium concentration     ',  'mmole-N/m3' ,  .false.     ,  .true.
-   sn_tracer(6)   = 'DOM' , 'Dissolved organic matter   ',  'mmole-N/m3' ,  .false.     ,  .true.
+!                ! name  !     title of the field          !   units       ! initial data ! save   !
+!                !       !                                 !               ! from file    ! or not ! 
+!                !       !                                 !               ! or not       !        !
+   sn_tracer(1)   = 'DET'   , 'Detritus                   ',  'mmole-N/m3' ,  .false.     ,  .false.
+   sn_tracer(2)   = 'ZOO'   , 'Zooplankton concentration  ',  'mmole-N/m3' ,  .false.     ,  .false.
+   sn_tracer(3)   = 'PHY'   , 'Phytoplankton concentration',  'mmole-N/m3' ,  .false.     ,  .false.
+   sn_tracer(4)   = 'NO3'   , 'Nitrate concentration      ',  'mmole-N/m3' ,  .false.     ,  .true.
+   sn_tracer(5)   = 'NH4'   , 'Ammonium concentration     ',  'mmole-N/m3' ,  .false.     ,  .false.
+   sn_tracer(6)   = 'DOM'   , 'Dissolved organic matter   ',  'mmole-N/m3' ,  .false.     ,  .false.
 /
 !-----------------------------------------------------------------------
-&namtrc_adv    !   advection scheme for passive tracer
+&namtrc_dta      !    Initialisation from data input file (T) or not (F)
 !-----------------------------------------------------------------------
-   ln_trcadv_cen2   =  .false.  !  2nd order centered scheme
+!
+!                !  file name  ! frequency (hours) ! variable   ! time interp. !  clim  ! 'yearly'/ ! weights  ! rotation !
+!                !             !  (if <0  months)  !   name     !   (logical)  !  (T/F) ! 'monthly' ! filename ! pairing  !
+   sn_trcdta(4)  = 'NO3_R1'    ,        -12        ,  'NO3'     ,    .false.   , .true. , 'yearly'  , ''       , ''
+
+   cn_dir        =     './'    !  root directory for the location of the runoff files
+   rn_trfac(4)   =    1.0      !   -       -       -       -      -
+/
+!-----------------------------------------------------------------------
+&namtrc_adv    !   advection scheme for passive tracer 
+!-----------------------------------------------------------------------
+   ln_trcadv_cen2   =  .false.  !  2nd order centered scheme   
    ln_trcadv_tvd    =  .true.   !  TVD scheme
    ln_trcadv_muscl  =  .false.  !  MUSCL scheme
@@ -51,4 +65,5 @@
    ln_trcldf_iso    =  .true.   !     iso-neutral                       (require "key_ldfslp")
 !                               !  Coefficient
+   rn_ahtrc_0       =  1000.    !  horizontal eddy diffusivity for tracers [m2/s]
    rn_ahtrb_0       =     0.    !     background eddy diffusivity for ldf_iso [m2/s]
 /
@@ -60,11 +75,12 @@
 /
 !-----------------------------------------------------------------------
-&namtrc_rad        !  treatment of negative concentrations
+&namtrc_rad        !  treatment of negative concentrations 
 !-----------------------------------------------------------------------
    ln_trcrad   =  .false.  !  artificially correct negative concentrations (T) or not (F)
 /
 !-----------------------------------------------------------------------
-&namtrc_dmp    !   passive tracer newtonian damping    ('key_tradmp && key_trcdmp')
+&namtrc_dmp    !   passive tracer newtonian damping  
 !-----------------------------------------------------------------------
+   ln_trcdmp   =  .false.  !  add a damping termn (T) or not (F)
    nn_hdmp_tr  =   -1      !  horizontal shape =-1, damping in Med and Red Seas only
                            !                   =XX, damping poleward of XX degrees (XX>0)
@@ -79,17 +95,18 @@
 /
 !-----------------------------------------------------------------------
-&namtrc_trd       !   diagnostics on tracer trends        ('key_trdtrc')
-!                          or mixed-layer trends          ('key_trdmld_trc')
+&namtrc_trd                !   diagnostics on tracer trends        ('key_trdtrc')
+!                                   or mixed-layer trends          ('key_trdmld_trc')
 !----------------------------------------------------------------------
-   nn_trd_trc   =  360      !  time step frequency and tracers trends
-   nn_ctls_trc  =   0       !  control surface type in mixed-layer trends (0,1 or n<jpk)
-   rn_ucf_trc   =  86400    !  unit conversion factor (=1 -> /seconds ; =86400. -> /day)
+   nn_trd_trc  =  5475      !  time step frequency and tracers trends
+   nn_ctls_trc =   0        !  control surface type in mixed-layer trends (0,1 or n<jpk)
+   rn_ucf_trc  =   1        !  unit conversion factor (=1 -> /seconds ; =86400. -> /day)
    ln_trdmld_trc_restart = .false.  !  restart for ML diagnostics
-   ln_trdmld_trc_instant = .false.  !  flag to diagnose trends of instantantaneous or mean ML T/S
+   ln_trdmld_trc_instant = .true.  !  flag to diagnose trends of instantantaneous or mean ML T/S
    ln_trdtrc(1)  =   .true.
-   ln_trdtrc(2)  =   .true.
-   ln_trdtrc(3)  =   .true.
-   ln_trdtrc(4)  =   .true.
-   ln_trdtrc(5)  =   .true.
-   ln_trdtrc(6)  =   .true.
 /
+!-----------------------------------------------------------------------
+&namtrc_dia       !   parameters for passive tracer additional diagnostics
+!----------------------------------------------------------------------
+   ln_diatrc     =  .true.   !  save additional diag. (T) or not (F)
+   nn_writedia   =  60     !  time step frequency for diagnostics
+/
Index: branches/2011/dev_LOCEAN_2011/NEMOGCM/CONFIG/GYRE_LOBSTER/cpp_GYRE_LOBSTER.fcm
===================================================================
--- branches/2011/dev_LOCEAN_2011/NEMOGCM/CONFIG/GYRE_LOBSTER/cpp_GYRE_LOBSTER.fcm	(revision 2976)
+++ branches/2011/dev_LOCEAN_2011/NEMOGCM/CONFIG/GYRE_LOBSTER/cpp_GYRE_LOBSTER.fcm	(revision 2977)
@@ -1,1 +1,1 @@
-bld::tool::fppkeys  key_gyre key_dynspg_flt key_ldfslp key_zdftke key_vectopt_loop key_top key_lobster key_diatrc key_iomput 
+bld::tool::fppkeys  key_gyre key_dynspg_flt key_ldfslp key_zdftke key_top key_lobster key_iomput 