Index: branches/2011/dev_r2802_UKMO8_sbccpl/DOC/TexFiles/Namelist/namsbc_cpl
===================================================================
--- branches/2011/dev_r2802_UKMO8_sbccpl/DOC/TexFiles/Namelist/namsbc_cpl	(revision 2811)
+++ branches/2011/dev_r2802_UKMO8_sbccpl/DOC/TexFiles/Namelist/namsbc_cpl	(revision 2982)
@@ -2,24 +2,22 @@
 &namsbc_cpl    !   coupled ocean/atmosphere model                       ("key_coupled")
 !-----------------------------------------------------------------------
-!                                      ! send
-cn_snd_temperature= 'weighted oce and ice'  !  'oce only' 'weighted oce and ice' 'mixed oce-ice'
-cn_snd_albedo     = 'weighted ice'          !  'none' 'weighted ice' 'mixed oce-ice'
-cn_snd_thickness  = 'none'                  !  'none' 'weighted ice and snow'
-cn_snd_crt_nature = 'none'                  !  'none' 'oce only' 'weighted oce and ice' 'mixed oce-ice'
-cn_snd_crt_refere = 'spherical'             !  'spherical' 'cartesian'
-cn_snd_crt_orient = 'eastward-northward'    !  'eastward-northward' or 'local grid'
-cn_snd_crt_grid   = 'T'                     !  'T'
-!                                      ! receive
-cn_rcv_w10m       = 'none'                  !  'none' 'coupled'
-cn_rcv_taumod     = 'coupled'               !  'none' 'coupled'
-cn_rcv_tau_nature = 'oce only'              !  'oce only' 'oce and ice' 'mixed oce-ice'
-cn_rcv_tau_refere = 'cartesian'             !  'spherical' 'cartesian'
-cn_rcv_tau_orient = 'eastward-northward'    !  'eastward-northward' or 'local grid'
-cn_rcv_tau_grid   = 'U,V'                   !  'T' 'U,V' 'U,V,F' 'U,V,I' 'T,F' 'T,I' 'T,U,V'
-cn_rcv_dqnsdt     = 'coupled'               !  'none' 'coupled'
-cn_rcv_qsr        = 'oce and ice'           !  'conservative' 'oce and ice' 'mixed oce-ice'
-cn_rcv_qns        = 'oce and ice'           !  'conservative' 'oce and ice' 'mixed oce-ice'
-cn_rcv_emp        = 'conservative'          !  'conservative' 'oce and ice' 'mixed oce-ice'
-cn_rcv_rnf        = 'coupled'               !  'coupled' 'climato' 'mixed'
-cn_rcv_cal        = 'coupled'               !  'none' 'coupled'
+!                    !     description       !  multiple  !    vector   !      vector          ! vector !
+!                    !                       ! categories !  reference  !    orientation       ! grids  !
+! send
+sn_snd_temp   =       'weighted oce and ice' ,    'no'    ,     ''      ,         ''           ,   ''    
+sn_snd_alb    =       'weighted ice'         ,    'no'    ,     ''      ,         ''           ,   ''    
+sn_snd_thick  =       'none'                 ,    'no'    ,     ''      ,         ''           ,   ''    
+sn_snd_crt    =       'none'                 ,    'no'    , 'spherical' , 'eastward-northward' ,  'T'       
+sn_snd_co2    =       'coupled'              ,    'no'    ,     ''      ,         ''           ,   ''        
+! receive
+sn_rcv_w10m   =       'none'                 ,    'no'    ,     ''      ,         ''          ,   ''    
+sn_rcv_taumod =       'coupled'              ,    'no'    ,     ''      ,         ''          ,   ''    
+sn_rcv_tau    =       'oce only'             ,    'no'    , 'cartesian' , 'eastward-northward',  'U,V'   
+sn_rcv_dqnsdt =       'coupled'              ,    'no'    ,     ''      ,         ''          ,   ''    
+sn_rcv_qsr    =       'oce and ice'          ,    'no'    ,     ''      ,         ''          ,   ''    
+sn_rcv_qns    =       'oce and ice'          ,    'no'    ,     ''      ,         ''          ,   ''    
+sn_rcv_emp    =       'conservative'         ,    'no'    ,     ''      ,         ''          ,   ''    
+sn_rcv_rnf    =       'coupled'              ,    'no'    ,     ''      ,         ''          ,   ''    
+sn_rcv_cal    =       'coupled'              ,    'no'    ,     ''      ,         ''          ,   ''    
+sn_rcv_co2    =       'coupled'              ,    'no'    ,     ''      ,         ''          ,   ''    
 /
Index: branches/2011/dev_r2802_UKMO8_sbccpl/DOC/TexFiles/Namelist/namsbc_cpl_co2
===================================================================
--- branches/2011/dev_r2802_UKMO8_sbccpl/DOC/TexFiles/Namelist/namsbc_cpl_co2	(revision 2811)
+++ 	(revision )
@@ -1,6 +1,0 @@
-!-----------------------------------------------------------------------
-&namsbc_cpl_co2   !   coupled ocean/biogeo/atmosphere model             ("key_cpl_carbon_cycle")
-!-----------------------------------------------------------------------
-   cn_snd_co2     = 'coupled'         ! send    : 'none' 'coupled'
-   cn_rcv_co2     = 'coupled'         ! receive : 'none' 'coupled'
-/