Index: branches/2011/dev_NOC_2011_MERGE/NEMOGCM/CONFIG/ORCA2_OFF_PISCES/cpp_ORCA2_OFF_PISCES.fcm
===================================================================
--- branches/2011/dev_NOC_2011_MERGE/NEMOGCM/CONFIG/ORCA2_OFF_PISCES/cpp_ORCA2_OFF_PISCES.fcm	(revision 2980)
+++ branches/2011/dev_NOC_2011_MERGE/NEMOGCM/CONFIG/ORCA2_OFF_PISCES/cpp_ORCA2_OFF_PISCES.fcm	(revision 2985)
@@ -1,1 +1,1 @@
-bld::tool::fppkeys key_trabbl key_vectopt_loop key_orca_r2 key_dynspg_flt key_ldfslp key_traldf_c2d key_traldf_eiv key_zdftke key_top key_offline key_pisces key_dtatrc key_diatrc key_iomput 
+bld::tool::fppkeys key_trabbl key_vectopt_loop key_orca_r2 key_ldfslp key_traldf_c2d key_traldf_eiv key_top key_offline key_pisces key_dtatrc key_diatrc key_iomput 
Index: branches/2011/dev_NOC_2011_MERGE/NEMOGCM/NEMO/OFF_SRC/domrea.F90
===================================================================
--- branches/2011/dev_NOC_2011_MERGE/NEMOGCM/NEMO/OFF_SRC/domrea.F90	(revision 2980)
+++ branches/2011/dev_NOC_2011_MERGE/NEMOGCM/NEMO/OFF_SRC/domrea.F90	(revision 2985)
@@ -254,4 +254,12 @@
             CALL iom_get( inum4, jpdom_unknown, 'e3t_0'  , e3t_0   )
             CALL iom_get( inum4, jpdom_unknown, 'e3w_0'  , e3w_0   )
+            DO jk = 1, jpk
+               e3t  (:,:,jk) = e3t_0(jk)                                     ! set to the ref. factors
+               e3u  (:,:,jk) = e3t_0(jk)
+               e3v  (:,:,jk) = e3t_0(jk)
+               e3w  (:,:,jk) = e3w_0(jk)
+               gdept(:,:,jk) = gdept_0(jk)
+               gdepw(:,:,jk) = gdepw_0(jk)
+            END DO
          ENDIF
 
Index: branches/2011/dev_NOC_2011_MERGE/NEMOGCM/NEMO/OPA_SRC/SBC/sbcrnf.F90
===================================================================
--- branches/2011/dev_NOC_2011_MERGE/NEMOGCM/NEMO/OPA_SRC/SBC/sbcrnf.F90	(revision 2980)
+++ branches/2011/dev_NOC_2011_MERGE/NEMOGCM/NEMO/OPA_SRC/SBC/sbcrnf.F90	(revision 2985)
@@ -438,6 +438,6 @@
       !!----------------------------------------------------------------------
       !
-      INTEGER           ::   inum        ! temporary integers
-      CHARACTER(len=32) ::   cl_rnfile   ! runoff file name
+      INTEGER            ::   inum        ! temporary integers
+      CHARACTER(len=140) ::   cl_rnfile   ! runoff file name
       !!----------------------------------------------------------------------
       ! 
Index: branches/2011/dev_NOC_2011_MERGE/NEMOGCM/NEMO/OPA_SRC/ZDF/zdfmxl.F90
===================================================================
--- branches/2011/dev_NOC_2011_MERGE/NEMOGCM/NEMO/OPA_SRC/ZDF/zdfmxl.F90	(revision 2980)
+++ branches/2011/dev_NOC_2011_MERGE/NEMOGCM/NEMO/OPA_SRC/ZDF/zdfmxl.F90	(revision 2985)
@@ -41,4 +41,5 @@
       !!               ***  FUNCTION zdf_mxl_alloc  ***
       !!----------------------------------------------------------------------
+      zdf_mxl_alloc = 0      ! set to zero if no array to be allocated
       IF( .NOT. ALLOCATED( nmln ) ) THEN
          ALLOCATE( nmln(jpi,jpj), hmld(jpi,jpj), hmlp(jpi,jpj), hmlpt(jpi,jpj), STAT= zdf_mxl_alloc )
Index: branches/2011/dev_NOC_2011_MERGE/NEMOGCM/NEMO/TOP_SRC/MY_TRC/trcini_my_trc.F90
===================================================================
--- branches/2011/dev_NOC_2011_MERGE/NEMOGCM/NEMO/TOP_SRC/MY_TRC/trcini_my_trc.F90	(revision 2980)
+++ branches/2011/dev_NOC_2011_MERGE/NEMOGCM/NEMO/TOP_SRC/MY_TRC/trcini_my_trc.F90	(revision 2985)
@@ -15,4 +15,5 @@
    USE oce_trc
    USE trc
+   USE trcsms_my_trc
 
    IMPLICIT NONE
@@ -38,7 +39,5 @@
 
       !                       ! Allocate MY_TRC arrays
-      IF( sms_lobster_alloc() /= 0 )   CALL ctl_stop( 'STOP', 'trc_ini_my_trc: unable to allocate MY_TRC arrays' )
-
-      CALL trc_ctl_my_trc     ! Control consitency
+      IF( trc_sms_my_trc_alloc() /= 0 )   CALL ctl_stop( 'STOP', 'trc_ini_my_trc: unable to allocate MY_TRC arrays' )
 
       IF(lwp) WRITE(numout,*)
@@ -49,26 +48,4 @@
       !
    END SUBROUTINE trc_ini_my_trc
-
-
-   SUBROUTINE trc_ctl_my_trc
-      !!----------------------------------------------------------------------
-      !!                     ***  ROUTINE trc_ctl_pisces  ***
-      !!
-      !! ** Purpose :   control the cpp options, namelist and files 
-      !!----------------------------------------------------------------------
-      INTEGER :: jl, jn
-      !!----------------------------------------------------------------------
-      !
-      IF(lwp) WRITE(numout,*)
-      IF(lwp) WRITE(numout,*) ' use COLOR tracer '
-      !
-      DO jl = 1, jp_my_trc
-         jn = jp_myt0 + jl - 1
-         WRITE( ctrcnm(jn),'(a,i2.2)' ) 'CLR', jn
-         ctrcnl(jn)='Color concentration'
-         ctrcun(jn)='N/A'
-      END DO
-      !
-   END SUBROUTINE trc_ctl_my_trc
 
 #else
Index: branches/2011/dev_NOC_2011_MERGE/NEMOGCM/NEMO/TOP_SRC/oce_trc.F90
===================================================================
--- branches/2011/dev_NOC_2011_MERGE/NEMOGCM/NEMO/TOP_SRC/oce_trc.F90	(revision 2980)
+++ branches/2011/dev_NOC_2011_MERGE/NEMOGCM/NEMO/TOP_SRC/oce_trc.F90	(revision 2985)
@@ -108,5 +108,4 @@
    USE dom_oce , ONLY :   e3w_0      =>   e3w_0      !: reference depth of w-points (m)
    USE dom_oce , ONLY :   gdepw_0    =>   gdepw_0    !: reference depth of w-points (m)
-# if ! defined key_zco
    USE dom_oce , ONLY :   gdep3w     =>  gdep3w      !: ???
    USE dom_oce , ONLY :   gdept      =>  gdept       !: depth of t-points (m)
@@ -119,5 +118,5 @@
    USE dom_oce , ONLY :   e3uw       =>  e3uw        !: uw-points (m)
    USE dom_oce , ONLY :   e3vw       =>  e3vw        !: vw-points (m)
-# endif
+
    USE dom_oce , ONLY :   ln_zps     =>  ln_zps      !: partial steps flag
    USE dom_oce , ONLY :   ln_sco     =>  ln_sco      !: s-coordinate flag